/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package createoto;
import com.fxcore2.*;
import java.io.FileNotFoundException;
import java.util.Scanner;
import java.util.concurrent.ConcurrentLinkedQueue;

public class Main {
    public static Scanner sc = new Scanner(System.in);
    private static EventPipe mEventPipe = null;
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        if (args.length < 4)
        {
                System.out.println("Not Enough Parameters!");
                System.out.println("USAGE: [user ID] [password] [URL] [connection] [session ID (if needed) or space (\" \")] [pin (if needed) or space (\" \")] ");
                System.out.println("\nPress any key to close the program");
                sc.next();
                return;
        }

        mEventPipe = new EventPipe();

        Runtime.getRuntime().addShutdownHook(new Thread() {
            public void run() {
                mEventPipe.putEvent(EventType.TERMINATE);
            }
        });

        LoginInfo loginInfo = null;

        String sUsername = args[0];
        String sPassword = args[1];
        String sHost = args[2];
        String sConnection = args[3];

        String sTradingSession = "";
        String sPIN = "";

        if (args.length > 4)
            sTradingSession = args[4];

        if (args.length > 5)
            sPIN = args[5];

        loginInfo = new LoginInfo(sUsername, sPassword, sHost, sConnection, sTradingSession, sPIN);

        login(loginInfo);
    }

   private static void login(LoginInfo loginInfo) {

        // "How to login" : Create session.
        O2GSession session = O2GTransport.createSession();

        SimpleLog simpleLog = null;
        try {
            simpleLog = new SimpleLog(String.format("%s.log", loginInfo.getUsername()));
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }

        simpleLog.log("Connecting to {0}", loginInfo.toString());

        // "How to login" : Create an instance of session status listener.
        SessionStatusListener sessionStatusListener = new SessionStatusListener(simpleLog, session, loginInfo, mEventPipe);

        // "How to login" : Subscribe status listener object to session status.
        session.subscribeSessionStatus(sessionStatusListener);

        // "How to login" : Create an instance of session response listener.
        ConcurrentLinkedQueue<O2GResponse> responseQueue = new ConcurrentLinkedQueue<O2GResponse>();

        ResponseListener responseListener = new ResponseListener(simpleLog, responseQueue, mEventPipe);

        // "How to login" : Subscribe response listener object to session response.
        session.subscribeResponse(responseListener);

        // "How to login" : The events are coming asynchronously.
        //                  They should come in another thread.
        //                  When the event will come, the signal will be sent to the main thread.

        EventListener eventListener = new EventListener(simpleLog, responseQueue, session, mEventPipe);

        // "How to login" : Login using user ID, password, URL, and connection.
        session.login(loginInfo.getUsername(), loginInfo.getPassword(), loginInfo.getConnection(), loginInfo.getConnectionName());

        eventListener.waitNextEvent();

        // "How to login" : Unsubscribe session from status listener.
        session.unsubscribeSessionStatus(sessionStatusListener);

        // "How to login" : Unsubscribe session from response listener.
        session.unsubscribeResponse(responseListener);

        session.dispose();
    }

}
