package joinnewcontingencygroup;

import java.io.File;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.Document;
import java.util.Scanner;
import org.xml.sax.SAXException;
import com.fxcore2.*;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.ConcurrentLinkedQueue;
import org.w3c.dom.NodeList;
public class Main {

        public static String sUserID = "";
        public static String sPassword = "";
        public static String sSessionID = "";
        public static String sPin = "";
        public static String sURL = "";
        public static String sConnection = "";
        public static String sPrimaryID = "";
        public static int iContingencyType = 0;
        public static List<String> listSecondary = new ArrayList<String>();
        public static Scanner sc = new Scanner(System.in);
        private static EventPipe mEventPipe = null;

    public static void main(String[] args) throws IOException {
    try
    {
        boolean bCannotRun = false;
         if (args.length < 1)
        {
                System.out.println("Not Enough Parameters! Please provide password");
                System.out.println("Press enter to close the program");
                sc.nextLine();
                return;
        }
        sPassword = args[0];
        File curDir = new File (".");
        String sCurDir = curDir.getCanonicalPath();
        String sXmlFile = sCurDir + File.separator + "joinnewgroup.xml";
        File xmlFile = new File(sXmlFile);
        boolean bExists = xmlFile.exists();
        if (!bExists)
        {
            System.out.println("File " + sXmlFile + " is missing");
            System.out.println("Press enter to close the program");
            sc.nextLine();
            return;
        }
        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
        DocumentBuilder db = null;
        try {
            db = dbf.newDocumentBuilder();
        } catch (ParserConfigurationException ex) {
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
            System.out.println("Cannot create DocumentBuilder");
            System.out.println("Press enter to close the program");
            sc.nextLine();
            return;
        }
        Document doc = null;
        try {
            doc = db.parse(xmlFile);
        } catch (SAXException ex) {
            System.out.println("Cannot parse file " + sXmlFile + "; " + ex.toString());
            System.out.println("Press enter to close the program");
            sc.nextLine();
            return;
        }
        try {
           sUserID = doc.getElementsByTagName("UserID").item(0).getTextContent();
           if (sUserID.isEmpty())
               throw new RuntimeException();
        }
        catch (RuntimeException e) {
            System.out.println("UserID value is missing from " + sXmlFile);
            bCannotRun = true;
        }
        try {
            sURL = doc.getElementsByTagName("URL").item(0).getTextContent();
            if (sURL.isEmpty())
                throw new RuntimeException();
        }
        catch (RuntimeException e) {
            System.out.println("URL value is missing from " + sXmlFile);
            bCannotRun = true;
        }
        try {
            sConnection = doc.getElementsByTagName("Connection").item(0).getTextContent();
            if (sConnection.isEmpty())
                throw new RuntimeException();
        }
        catch (RuntimeException e) {
            System.out.println("Connection value is missing from " + sXmlFile);
            bCannotRun = true;
        }
        try {
            sPrimaryID = doc.getElementsByTagName("PrimaryID").item(0).getTextContent();
            if (sPrimaryID.isEmpty())
                throw new RuntimeException();
        }
        catch (RuntimeException e) {
            System.out.println("PrimaryID value is missing from " + sXmlFile);
            bCannotRun = true;
        }
        String sContingencyType = "";
        try {
            sContingencyType = doc.getElementsByTagName("ContingencyType").item(0).getTextContent();
            if (sContingencyType.isEmpty())
                throw new RuntimeException();
        }
        catch (RuntimeException e) {
            System.out.println("ContingencyType value is missing from " + sXmlFile);
            bCannotRun = true;
        }
        if (!(sContingencyType.equals("1") || sContingencyType.equals("2") || sContingencyType.equals("3")))
        {
            System.out.println("ContingencyType " + sContingencyType + " is invalid");
            bCannotRun = true;
        }
        else
            iContingencyType = Integer.parseInt(sContingencyType);

        try {
            NodeList secondaryOrders = doc.getElementsByTagName("SecondaryID");
            if (secondaryOrders.getLength()== 0) {
                throw new RuntimeException();
            }
            else {
                for (int j = 0; j < secondaryOrders.getLength(); j++)
                {
                    String sSecondaryOrder = secondaryOrders.item(j).getTextContent();
                    listSecondary.add(sSecondaryOrder);
                }
            }
        }
        catch (RuntimeException e) {
            System.out.println("SecondaryID value(s) are missing from " + sXmlFile);
            bCannotRun = true;
        }


        if (bCannotRun) {
            System.out.println("Press enter to close the program");
            sc.nextLine();
            return;
        }
        try {
            sSessionID = doc.getElementsByTagName("Session").item(0).getTextContent();
            sPin= doc.getElementsByTagName("Pin").item(0).getTextContent();
        }
        catch (RuntimeException e) {
        }
        Runtime.getRuntime().addShutdownHook(new Thread() {
            public void run() {
                mEventPipe.putEvent(EventType.TERMINATE);
            }
        });
        mEventPipe = new EventPipe();
        LoginInfo loginInfo = null;
        loginInfo = new LoginInfo(sUserID, sPassword, sURL, sConnection, sSessionID, sPin);
        login(loginInfo);
    }
    catch (RuntimeException e)
    {
        System.out.println("Exception: " + e.toString());
    }
    }

  private static void login(LoginInfo loginInfo) {

        // "How to login" : Create session.
        O2GSession session = O2GTransport.createSession();
        SimpleLog simpleLog = null;
        try {
            simpleLog = new SimpleLog(String.format("%s.log", loginInfo.getUsername()));
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }

        simpleLog.log("Connecting to {0}", loginInfo.toString());

        // "How to login" : Create an instance of session status listener.
        SessionStatusListener sessionStatusListener = new SessionStatusListener(simpleLog, session, loginInfo, mEventPipe);

        // "How to login" : Subscribe status listener object to session status.
        session.subscribeSessionStatus(sessionStatusListener);

        // "How to login" : Create an instance of session response listener.
        ConcurrentLinkedQueue<O2GResponse> responseQueue = new ConcurrentLinkedQueue<O2GResponse>();

        ResponseListener responseListener = new ResponseListener(simpleLog, responseQueue, mEventPipe);

        // "How to login" : Subscribe response listener object to session response.
        session.subscribeResponse(responseListener);

        // "How to login" : The events are coming asynchronously.
        //                  They should come in another thread.
        //                  When the event will come, the signal will be sent to the main thread.

        EventListener eventListener = new EventListener(simpleLog, responseQueue, session, mEventPipe);

        // "How to login" : Login using user ID, password, URL, and connection.
        session.login(loginInfo.getUsername(), loginInfo.getPassword(), loginInfo.getConnection(), loginInfo.getConnectionName());

        eventListener.waitNextEvent();

        // "How to login" : Unsubscribe session from status listener.
        session.unsubscribeSessionStatus(sessionStatusListener);

        // "How to login" : Unsubscribe session from response listener.
        session.unsubscribeResponse(responseListener);

        session.dispose();
    }
}
