
package login;
import com.fxcore2.*;

public class mySessionStatusListener implements IO2GSessionStatus {
        private boolean mConnected = false;
    private boolean mDiconnected = false;
    private boolean mError = false;
    private O2GSession mSession;

    public mySessionStatusListener(O2GSession session)
    {
        mSession = session;
    }
    public final boolean getConnected()
    {
        return mConnected;
    }
    public final boolean getDisconnected()
    {
        return mDiconnected;
    }
    public final boolean getError()
    {
        return mError;
    }
    public final void onSessionStatusChanged(O2GSessionStatusCode status)
    {
        System.out.println("Status: " + status.toString());
        if (status == O2GSessionStatusCode.CONNECTED)
        {
            mConnected = true;
        }
        else
        {
            mConnected = false;
        }

        if (status == O2GSessionStatusCode.DISCONNECTED)
        {
            mDiconnected = true;
        }
        else
        {
            mDiconnected = false;
        }

        if (status == O2GSessionStatusCode.TRADING_SESSION_REQUESTED)
        {
            O2GSessionDescriptorCollection descs = mSession.getTradingSessionDescriptors();
            System.out.println("\nSession descriptors");
            System.out.println("id, name, description, requires pin");
            for (O2GSessionDescriptor desc : descs)
            {
                            System.out.println(desc.getId() + " " + desc.getName() + " " + desc.getDescription() + " " + desc.isPinRequired());
            }
            System.out.println();

            if (Main.strSessionID.equals(""))
            {
                System.out.println("Argument for trading session ID is missing");
            }
            else
            {
                mSession.setTradingSession(Main.strSessionID, Main.strPin);
            }
        }

    }
    public final void onLoginFailed(String error)
    {
        System.out.println("Login error: " + error);
        mError = true;
    }

}
